#ifndef KYDIMA_H
#define KYDIMA_H
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>
#include <stdlib.h>
#include <vector>
#include <map>
#include <algorithm>


#pragma once
using namespace std;

#ifndef PATH_MAX
#define PATH_MAX 1024
#endif

struct HashInfo
{
    char vmstart_end[1024];
    int modified;
    char base_hash[1024];
    char filePath[1024];
};
struct PidInfo
{
    int pid;
    char firstTime[1024];
    char lastTime[1024];
    int modified;
    char base_hash[1024];
    vector<HashInfo> hashInfo;
};
struct processesInfo
{
    char filePath[1024];
    int enforce;
    int modified;
    vector<PidInfo> proInfo;
};

struct MHashInfo
{
    char vmstart_end[1024];
    int modified;
    char base_hash[1024];
};
struct modulesInfo
{
    char filePath[1024];
    int enforce;
    char firstTime[1024];
    char lastTime[1024];
    int modified;
    char base_hash[1024];
    vector<MHashInfo> mhashInfo;
};

#ifdef __cplusplus
extern "C" {
#endif
	/* 进程策略添加*/
	extern int kydima_set_process_policy(const char* process,const char* op, int enforce);
	//extern int kydima_set_processpid_policy(const int pid, const char* op,int enforce);
	/* 模块策略添加*/
	extern int kydima_set_module_policy(const char * module,const char* op);
	/* 度量周期设置*/
	extern int kydima_set_cycle(int cycle);
	/* 度量开关设置*/
	extern int kydima_set_switch(int status);
	/* pcr设置*/
	extern int kydima_set_pcr(int registernum, const char* tpm);

	/* 进程策略查询*/
	extern int kydima_get_process_policy(const char* process,char** op,int *enforce);
	/* 进程策略查询*/
	//extern int kydima_get_processpid_policy(const int pid,char** op,int *enforce);
	/* 模块策略查询*/
	extern int kydima_get_module_status(const char* module,int *status);
	/* 度量周期查询*/
	extern int kydima_get_cycle(int *cycle);
	/* 度量开关查询*/
	extern int kydima_get_switch(int *status);
	/* event开关查询*/
     extern int kydima_get_event(int *status);
	 /* pcr设置*/
	extern int kydima_get_pcr(int *registernum, char** tpm);

	 
	/* 进程日志查询*/
	extern int kydima_get_process_all();
	/* 获取模块度量信息*/
	extern int kydima_get_Module_MeasureInfo(vector<modulesInfo> &vecModulesInfo);
	/* 获取进程度量信息*/
	extern int kydima_get_Process_MeasureInfo(vector<processesInfo> &vecProcessInfo);
	
#ifdef __cplusplus
}
#endif

#endif // KYDIMA_H
	
